/* global.h -- global variable declarations for lparse
      
   This program has no warranties of any kind. Use at own risk.

   Author: Tommi Syrjnen (tommi.syrjanen@hut.fi)

   $Id: extern.h,v 1.1 1998/08/04 09:18:50 tssyrjan Exp $	 
*/

#ifndef EXTERN_H
#define EXTERN_H

class SymbolTable;
class FunctionTable;
struct ComputeStmt;
struct ParseNode;
class PredicateArray;
class Graph;
class Literal;

extern Literal *false_lit;
extern ParseNode *logic_program;
extern FunctionTable *function_table;
extern SymbolTable *predicate_table;
extern SymbolTable *variable_table;
extern SymbolTable *constant_table;
extern SymbolTable *atom_table;
extern int errno;
extern long primes[];
extern SysData sys_data;
extern char *operators[];
extern char *function_strings[];
extern ComputeStmt *compute;
extern char *parse_strings[];
extern Graph *dependency_graph;
extern PredicateArray predicates;
extern Variable *variables;
extern Variable *var_pos;
extern ParseNode *c_stmt;
extern char *external_files[];
#endif
